/**
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 * @format
 */
'use strict';
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.supportKeyboard = void 0;
const react_1 = __importDefault(require("react"));
/**
 * @deprecated - Exported types should already have the keyboarding properties on them
 */
const supportKeyboard = (WrappedComponent) => {
    class SupportKeyboard extends react_1.default.Component {
        render() {
            const { forwardedRef, ...rest } = this.props;
            return (react_1.default.createElement(WrappedComponent, { ref: forwardedRef, ...rest }));
        }
    }
    return react_1.default.forwardRef((props, ref) => {
        return react_1.default.createElement(SupportKeyboard, { ...props, forwardedRef: ref });
    });
};
exports.supportKeyboard = supportKeyboard;
//# sourceMappingURL=KeyboardExt.js.map