// Copyright (c) Microsoft Corporation.
// Licensed under the MIT License.
#pragma once

// This file lists well-known values for standard XAML control
// Resource keys to reduce typos and string duplication.

// https://docs.microsoft.com/en-us/uwp/api/Windows.UI.Xaml.Controls.TextBox#control-style-and-template
static const wchar_t *c_textControlForeground = L"TextControlForeground";
static const wchar_t *c_textControlForegroundPointerOver = L"TextControlForegroundPointerOver";
static const wchar_t *c_textControlForegroundFocused = L"TextControlForegroundFocused";
static const wchar_t *c_textControlForegroundDisabled = L"TextControlForegroundDisabled";
static const wchar_t *c_textControlBackground = L"TextControlBackground";
static const wchar_t *c_textControlBackgroundPointerOver = L"TextControlBackgroundPointerOver";
static const wchar_t *c_textControlBackgroundFocused = L"TextControlBackgroundFocused";
static const wchar_t *c_textControlBackgroundDisabled = L"TextControlBackgroundDisabled";
static const wchar_t *c_textControlBorderBrush = L"TextControlBorderBrush";
static const wchar_t *c_textControlBorderBrushPointerOver = L"TextControlBorderBrushPointerOver";
static const wchar_t *c_textControlBorderBrushFocused = L"TextControlBorderBrushFocused";
static const wchar_t *c_textControlBorderBrushDisabled = L"TextControlBorderBrushDisabled";
static const wchar_t *c_textControlPlaceholderForeground = L"TextControlPlaceholderForeground";
static const wchar_t *c_textControlPlaceholderForegroundPointerOver = L"TextControlPlaceholderForegroundPointerOver";
static const wchar_t *c_textControlPlaceholderForegroundFocused = L"TextControlPlaceholderForegroundFocused";
static const wchar_t *c_textControlPlaceholderForegroundDisabled = L"TextControlPlaceholderForegroundDisabled";
static const wchar_t *c_textControlHeaderForeground = L"TextControlHeaderForeground";
static const wchar_t *c_textControlHeaderForegroundDisabled = L"TextControlHeaderForegroundDisabled";
static const wchar_t *c_textControlSelectionHighlightColor = L"TextControlSelectionHighlightColor";
static const wchar_t *c_textControlButtonBackground = L"TextControlButtonBackground";
static const wchar_t *c_textControlButtonBackgroundPointerOver = L"TextControlButtonBackgroundPointerOver";
static const wchar_t *c_textControlButtonBackgroundPressed = L"TextControlButtonBackgroundPressed";
static const wchar_t *c_textControlButtonBorderBrush = L"TextControlButtonBorderBrush";
static const wchar_t *c_textControlButtonBorderBrushPointerOver = L"TextControlButtonBorderBrushPointerOver";
static const wchar_t *c_textControlButtonBorderBrushPressed = L"TextControlButtonBorderBrushPressed";
static const wchar_t *c_textControlButtonForeground = L"TextControlButtonForeground";
static const wchar_t *c_textControlButtonForegroundPointerOver = L"TextControlButtonForegroundPointerOver";
static const wchar_t *c_textControlButtonForegroundPressed = L"TextControlButtonForegroundPressed";

// https://docs.microsoft.com/en-us/uwp/api/Windows.UI.Xaml.Controls.ToggleSwitch#control-style-and-template
static const wchar_t *c_toggleSwitchContainerBackground = L"ToggleSwitchContainerBackground";
static const wchar_t *c_toggleSwitchContainerBackgroundPointerOver = L"ToggleSwitchContainerBackgroundPointerOver";
static const wchar_t *c_toggleSwitchContainerBackgroundPressed = L"ToggleSwitchContainerBackgroundPressed";
static const wchar_t *c_toggleSwitchContainerBackgroundDisabled = L"ToggleSwitchContainerBackgroundDisabled";
static const wchar_t *c_toggleSwitchContentForeground = L"ToggleSwitchContentForeground";
static const wchar_t *c_toggleSwitchContentForegroundDisabled = L"ToggleSwitchContentForegroundDisabled";
static const wchar_t *c_toggleSwitchHeaderForeground = L"ToggleSwitchHeaderForeground";
static const wchar_t *c_toggleSwitchHeaderForegroundDisabled = L"ToggleSwitchHeaderForegroundDisabled";
static const wchar_t *c_toggleSwitchFillOff = L"ToggleSwitchFillOff";
static const wchar_t *c_toggleSwitchFillOffPointerOver = L"ToggleSwitchFillOffPointerOver";
static const wchar_t *c_toggleSwitchFillOffPressed = L"ToggleSwitchFillOffPressed";
static const wchar_t *c_toggleSwitchFillOffDisabled = L"ToggleSwitchFillOffDisabled";
static const wchar_t *c_toggleSwitchFillOn = L"ToggleSwitchFillOn";
static const wchar_t *c_toggleSwitchFillOnPointerOver = L"ToggleSwitchFillOnPointerOver";
static const wchar_t *c_toggleSwitchFillOnPressed = L"ToggleSwitchFillOnPressed";
static const wchar_t *c_toggleSwitchFillOnDisabled = L"ToggleSwitchFillOnDisabled";
static const wchar_t *c_toggleSwitchStrokeOff = L"ToggleSwitchStrokeOff";
static const wchar_t *c_toggleSwitchStrokeOffPointerOver = L"ToggleSwitchStrokeOffPointerOver";
static const wchar_t *c_toggleSwitchStrokeOffPressed = L"ToggleSwitchStrokeOffPressed";
static const wchar_t *c_toggleSwitchStrokeOffDisabled = L"ToggleSwitchStrokeOffDisabled";
static const wchar_t *c_toggleSwitchStrokeOn = L"ToggleSwitchStrokeOn";
static const wchar_t *c_toggleSwitchStrokeOnPointerOver = L"ToggleSwitchStrokeOnPointerOver";
static const wchar_t *c_toggleSwitchStrokeOnPressed = L"ToggleSwitchStrokeOnPressed";
static const wchar_t *c_toggleSwitchStrokeOnDisabled = L"ToggleSwitchStrokeOnDisabled";
static const wchar_t *c_toggleSwitchKnobFillOff = L"ToggleSwitchKnobFillOff";
static const wchar_t *c_toggleSwitchKnobFillOffPointerOver = L"ToggleSwitchKnobFillOffPointerOver";
static const wchar_t *c_toggleSwitchKnobFillOffPressed = L"ToggleSwitchKnobFillOffPressed";
static const wchar_t *c_toggleSwitchKnobFillOffDisabled = L"ToggleSwitchKnobFillOffDisabled";
static const wchar_t *c_toggleSwitchKnobFillOn = L"ToggleSwitchKnobFillOn";
static const wchar_t *c_toggleSwitchKnobFillOnPointerOver = L"ToggleSwitchKnobFillOnPointerOver";
static const wchar_t *c_toggleSwitchKnobFillOnPressed = L"ToggleSwitchKnobFillOnPressed";
static const wchar_t *c_toggleSwitchKnobFillOnDisabled = L"ToggleSwitchKnobFillOnDisabled";
